
Unit opdrawalpha32;

{$mode objfpc}{$H+}

Interface

Uses opbitmap;

Procedure OpBitmapPaint32(Handle: THandle; Bmp: TOpBitmap; X, Y: integer;
          SourcePrepared:boolean=false);
Procedure OpBitmapPreMultiply(Source,Target: TOPBitmap);

Implementation

Uses Cairo, gdk2, gtkDef;

{$i PreMultipliedTable.inc}

Function gdk_cairo_create(drawable: PGdkDrawable): Pcairo_t; cdecl; external gdklib;

Procedure OpBitmapPreMultiply(Source,Target: TOPBitmap);
Var i: integer;
  sarr,tarr: PAPixel32;
Begin
  Source.PixelFormat := pf32bit;
  Target.PixelFormat := pf32bit;
  If (Target.Width<>Source.Width) Or (Target.Height<>Source.Height) Then
    Begin;
      Target.Height := 0;
      Target.Width := Source.Width;
      Target.Height := Source.Height;
    End;
  i := 0;
  sarr := TBitmapData32(Source.Data).RawArray;
  tarr := TBitmapData32(Target.Data).RawArray;
  For i:=0 To (Source.Width*Source.Height) Do
    Begin
      tarr^[i].Blue := PreMultipliedTable[sarr^[i].Blue][sarr^[i].Alpha];
      tarr^[i].Red := PreMultipliedTable[sarr^[i].Red][sarr^[i].Alpha];
      tarr^[i].Green := PreMultipliedTable[sarr^[i].Green][sarr^[i].Alpha];
      tarr^[i].Alpha := sarr^[i].Alpha;
    End;
End;

Procedure OpBitmapPaint32(Handle: THandle; Bmp: TOpBitmap; X, Y: integer;
          SourcePrepared:boolean=false);
Var cr: Pcairo_t;
  surface: Pcairo_surface_t;
  TempBmp: TOPBitmap;
Begin
  If Not SourcePrepared Then
    Begin
      TempBmp := TOPBitmap.Create;
      OpBitmapPreMultiply(Bmp,TempBmp);
      Bmp := TempBmp;
    End Else Bmp.PixelFormat := pf32bit;

  cr := gdk_cairo_create(TGtkDeviceContext(Handle).Drawable);
  surface := cairo_image_surface_create_for_data(Bmp.ScanLine[0], CAIRO_FORMAT_ARGB32, Bmp.Width,
             Bmp.Height, Bmp.Data.LineLength);
  If surface <> Nil Then
    Begin
      cairo_set_source_surface(cr, surface, X, Y);
      cairo_paint(cr);
      cairo_surface_destroy(surface);
    End;
  cairo_destroy(cr);
  If Not SourcePrepared Then TempBmp.free;
End;


End.

